--- old/usr/src/common/crypto/des/des_impl.c	Thu Apr 30 20:52:30 2015
+++ new/usr/src/common/crypto/des/des_impl.c	Thu Apr 30 20:52:30 2015
@@ -22,6 +22,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #include <sys/types.h>
 #include <sys/systm.h>
@@ -986,7 +989,7 @@
 }
 
 void
-des_copy_block(uint8_t *in, uint8_t *out)
+des_copy_block(const uint8_t *in, uint8_t *out)
 {
 	if (IS_P2ALIGNED(in, sizeof (uint32_t)) &&
 	    IS_P2ALIGNED(out, sizeof (uint32_t))) {
@@ -1001,7 +1004,7 @@
 
 /* XOR block of data into dest */
 void
-des_xor_block(uint8_t *data, uint8_t *dst)
+des_xor_block(const uint8_t *data, uint8_t *dst)
 {
 	if (IS_P2ALIGNED(dst, sizeof (uint32_t)) &&
 	    IS_P2ALIGNED(data, sizeof (uint32_t))) {
@@ -1056,19 +1059,19 @@
 		if (des_ctx->dc_flags & CBC_MODE) {
 			rv = cbc_encrypt_contiguous_blocks(ctx, data,
 			    length, out, DES_BLOCK_LEN, des3_encrypt_block,
-			    des_copy_block, des_xor_block);
+			    des_copy_block, des_xor_block, NULL);
 		} else {
 			rv = ecb_cipher_contiguous_blocks(ctx, data, length,
-			    out, DES_BLOCK_LEN, des3_encrypt_block);
+			    out, DES_BLOCK_LEN, des3_encrypt_block, NULL);
 		}
 	} else {
 		if (des_ctx->dc_flags & CBC_MODE) {
 			rv = cbc_encrypt_contiguous_blocks(ctx, data,
 			    length, out, DES_BLOCK_LEN, des_encrypt_block,
-			    des_copy_block, des_xor_block);
+			    des_copy_block, des_xor_block, NULL);
 		} else {
 			rv = ecb_cipher_contiguous_blocks(ctx, data, length,
-			    out, DES_BLOCK_LEN, des_encrypt_block);
+			    out, DES_BLOCK_LEN, des_encrypt_block, NULL);
 		}
 	}
 	return (rv);
@@ -1088,10 +1091,10 @@
 		if (des_ctx->dc_flags & CBC_MODE) {
 			rv = cbc_decrypt_contiguous_blocks(ctx, data,
 			    length, out, DES_BLOCK_LEN, des3_decrypt_block,
-			    des_copy_block, des_xor_block);
+			    des_copy_block, des_xor_block, NULL, NULL);
 		} else {
 			rv = ecb_cipher_contiguous_blocks(ctx, data, length,
-			    out, DES_BLOCK_LEN, des3_decrypt_block);
+			    out, DES_BLOCK_LEN, des3_decrypt_block, NULL);
 			if (rv == CRYPTO_DATA_LEN_RANGE)
 				rv = CRYPTO_ENCRYPTED_DATA_LEN_RANGE;
 		}
@@ -1099,10 +1102,10 @@
 		if (des_ctx->dc_flags & CBC_MODE) {
 			rv = cbc_decrypt_contiguous_blocks(ctx, data,
 			    length, out, DES_BLOCK_LEN, des_decrypt_block,
-			    des_copy_block, des_xor_block);
+			    des_copy_block, des_xor_block, NULL, NULL);
 		} else {
 			rv = ecb_cipher_contiguous_blocks(ctx, data, length,
-			    out, DES_BLOCK_LEN, des_decrypt_block);
+			    out, DES_BLOCK_LEN, des_decrypt_block, NULL);
 			if (rv == CRYPTO_DATA_LEN_RANGE)
 				rv = CRYPTO_ENCRYPTED_DATA_LEN_RANGE;
 		}
--- old/usr/src/common/crypto/des/des_impl.h	Thu Apr 30 20:52:30 2015
+++ new/usr/src/common/crypto/des/des_impl.h	Thu Apr 30 20:52:30 2015
@@ -22,6 +22,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #ifndef	_DES_IMPL_H
 #define	_DES_IMPL_H
@@ -97,8 +100,8 @@
 extern void *des_alloc_keysched(size_t *, des_strength_t, int);
 extern boolean_t des_keycheck(uint8_t *, des_strength_t, uint8_t *);
 extern void des_parity_fix(uint8_t *, des_strength_t, uint8_t *);
-extern void des_copy_block(uint8_t *, uint8_t *);
-extern void des_xor_block(uint8_t *, uint8_t *);
+extern void des_copy_block(const uint8_t *, uint8_t *);
+extern void des_xor_block(const uint8_t *, uint8_t *);
 extern int des_encrypt_block(const void *, const uint8_t *, uint8_t *);
 extern int des3_encrypt_block(const void *, const uint8_t *, uint8_t *);
 extern int des_decrypt_block(const void *, const uint8_t *, uint8_t *);
--- old/usr/src/common/crypto/modes/amd64/gcm_intel.s	Thu Apr 30 20:52:30 2015
+++ new/usr/src/common/crypto/modes/amd64/gcm_intel.s	Thu Apr 30 20:52:30 2015
@@ -27,6 +27,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 /*
  * Accelerated GHASH implementation with Intel PCLMULQDQ-NI
@@ -90,6 +93,20 @@
 gcm_mul_pclmulqdq(uint64_t *x_in, uint64_t *y, uint64_t *res) {
 }
 
+#ifdef	_KERNEL
+/*ARGSUSED*/
+void
+gcm_intel_save(void *savestate)
+{
+}
+
+/*ARGSUSED*/
+void
+gcm_accel_restore(void *savestate)
+{
+}
+#endif	/* _KERNEL */
+
 #else	/* lint */
 
 #include <sys/asm_linkage.h>
@@ -116,81 +133,90 @@
 #define	PROTECTED_CLTS \
 	CLTS
 #endif	/* __xpv */
-
-	/*
-	 * If CR0_TS is not set, align stack (with push %rbp) and push
-	 * %xmm0 - %xmm10 on stack, otherwise clear CR0_TS
-	 */
-#define	CLEAR_TS_OR_PUSH_XMM_REGISTERS(tmpreg) \
-	push	%rbp; \
-	mov	%rsp, %rbp; \
-	movq	%cr0, tmpreg; \
-	testq	$CR0_TS, tmpreg; \
-	jnz	1f; \
-	and	$-XMM_ALIGN, %rsp; \
-	sub	$[XMM_SIZE * 11], %rsp; \
-	movaps	%xmm0, 160(%rsp); \
-	movaps	%xmm1, 144(%rsp); \
-	movaps	%xmm2, 128(%rsp); \
-	movaps	%xmm3, 112(%rsp); \
-	movaps	%xmm4, 96(%rsp); \
-	movaps	%xmm5, 80(%rsp); \
-	movaps	%xmm6, 64(%rsp); \
-	movaps	%xmm7, 48(%rsp); \
-	movaps	%xmm8, 32(%rsp); \
-	movaps	%xmm9, 16(%rsp); \
-	movaps	%xmm10, (%rsp); \
-	jmp	2f; \
-1: \
-	PROTECTED_CLTS; \
-2:
-
-
-	/*
-	 * If CR0_TS was not set above, pop %xmm0 - %xmm10 off stack,
-	 * otherwise set CR0_TS.
-	 */
-#define	SET_TS_OR_POP_XMM_REGISTERS(tmpreg) \
-	testq	$CR0_TS, tmpreg; \
-	jnz	1f; \
-	movaps	(%rsp), %xmm10; \
-	movaps	16(%rsp), %xmm9; \
-	movaps	32(%rsp), %xmm8; \
-	movaps	48(%rsp), %xmm7; \
-	movaps	64(%rsp), %xmm6; \
-	movaps	80(%rsp), %xmm5; \
-	movaps	96(%rsp), %xmm4; \
-	movaps	112(%rsp), %xmm3; \
-	movaps	128(%rsp), %xmm2; \
-	movaps	144(%rsp), %xmm1; \
-	movaps	160(%rsp), %xmm0; \
-	jmp	2f; \
-1: \
-	STTS(tmpreg); \
-2: \
-	mov	%rbp, %rsp; \
-	pop	%rbp
-
-
-#else
-#define	PROTECTED_CLTS
-#define	CLEAR_TS_OR_PUSH_XMM_REGISTERS(tmpreg)
-#define	SET_TS_OR_POP_XMM_REGISTERS(tmpreg)
 #endif	/* _KERNEL */
 
-/*
- * Use this mask to byte-swap a 16-byte integer with the pshufb instruction
- */
-
-// static uint8_t byte_swap16_mask[] = {
-//	 15, 14, 13, 12, 11, 10, 9, 8, 7, 6 ,5, 4, 3, 2, 1, 0 };
 .text
 .align XMM_ALIGN
+/*
+ * Use this mask to byte-swap a 16-byte integer with the pshufb instruction:
+ * static uint8_t byte_swap16_mask[] = {
+ *	15, 14, 13, 12, 11, 10, 9, 8, 7, 6 ,5, 4, 3, 2, 1, 0 };
+ */
 .Lbyte_swap16_mask:
 	.byte	15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0
 
+#ifdef	_KERNEL
+/*
+ * void gcm_intel_save(void *savestate)
+ *
+ * Saves the XMM0--XMM14 registers and CR0 to a temporary location pointed
+ * to in the first argument and clears TS in CR0. This must be invoked before
+ * executing accelerated GCM computations inside the kernel (and kernel
+ * thread preemption must be disabled as well). The memory region to which
+ * all state is saved must be at least 16x 128-bit + 64-bit long and must
+ * be 128-bit aligned.
+ */
+ENTRY_NP(gcm_accel_save)
+	movq	%cr0, %rax
+	movq	%rax, 0x100(%rdi)
+	testq	$CR0_TS, %rax
+	jnz	1f
+	/* FPU is in use, save registers */
+	movaps	%xmm0, 0x00(%rdi)
+	movaps	%xmm1, 0x10(%rdi)
+	movaps	%xmm2, 0x20(%rdi)
+	movaps	%xmm3, 0x30(%rdi)
+	movaps	%xmm4, 0x40(%rdi)
+	movaps	%xmm5, 0x50(%rdi)
+	movaps	%xmm6, 0x60(%rdi)
+	movaps	%xmm7, 0x70(%rdi)
+	movaps	%xmm8, 0x80(%rdi)
+	movaps	%xmm9, 0x90(%rdi)
+	movaps	%xmm10, 0xa0(%rdi)
+	movaps	%xmm11, 0xb0(%rdi)
+	movaps	%xmm12, 0xc0(%rdi)
+	movaps	%xmm13, 0xd0(%rdi)
+	movaps	%xmm14, 0xe0(%rdi)
+	movaps	%xmm15, 0xf0(%rdi)
+	ret
+1:
+	PROTECTED_CLTS
+	ret
+	SET_SIZE(gcm_accel_save)
 
+/*
+ * void gcm_accel_restore(void *savestate)
+ *
+ * Restores the saved XMM and CR0.TS state from aes_accel_save.
+ */
+ENTRY_NP(gcm_accel_restore)
+	movq	0x100(%rdi), %rax
+	testq	$CR0_TS, %rax
+	jnz	1f
+	movaps	0x00(%rdi), %xmm0
+	movaps	0x10(%rdi), %xmm1
+	movaps	0x20(%rdi), %xmm2
+	movaps	0x30(%rdi), %xmm3
+	movaps	0x40(%rdi), %xmm4
+	movaps	0x50(%rdi), %xmm5
+	movaps	0x60(%rdi), %xmm6
+	movaps	0x70(%rdi), %xmm7
+	movaps	0x80(%rdi), %xmm8
+	movaps	0x90(%rdi), %xmm9
+	movaps	0xa0(%rdi), %xmm10
+	movaps	0xb0(%rdi), %xmm11
+	movaps	0xc0(%rdi), %xmm12
+	movaps	0xd0(%rdi), %xmm13
+	movaps	0xe0(%rdi), %xmm14
+	movaps	0xf0(%rdi), %xmm15
+	ret
+1:
+	STTS(%rax)
+	ret
+	SET_SIZE(gcm_accel_restore)
 
+#endif	/* _KERNEL */
+
 /*
  * void gcm_mul_pclmulqdq(uint64_t *x_in, uint64_t *y, uint64_t *res);
  *
@@ -199,14 +225,11 @@
  *
  * Byte swap the input and the output.
  *
- * Note: x_in, y, and res all point to a block of 20-byte numbers
+ * Note: x_in, y, and res all point to a block of 16-byte numbers
  * (an array of two 64-bit integers).
  *
- * Note2: For kernel code, caller is responsible for ensuring
- * kpreempt_disable() has been called.  This is because %xmm registers are
- * not saved/restored.  Clear and set the CR0.TS bit on entry and exit,
- * respectively, if TS is set on entry.  Otherwise, if TS is not set,
- * save and restore %xmm registers on the stack.
+ * Note2: For kernel code, caller is responsible for bracketing this call with
+ * disabling kernel thread preemption and calling gcm_accel_save/restore().
  *
  * Note3: Original Intel definition:
  * void galois_hash_asm(unsigned char *hk, unsigned char *s,
@@ -224,8 +247,6 @@
  */
 
 ENTRY_NP(gcm_mul_pclmulqdq)
-	CLEAR_TS_OR_PUSH_XMM_REGISTERS(%r10)
-
 	//
 	// Copy Parameters
 	//
@@ -330,7 +351,6 @@
 	//
 	// Cleanup and Return
 	//
-	SET_TS_OR_POP_XMM_REGISTERS(%r10)
 	ret
 	SET_SIZE(gcm_mul_pclmulqdq)
 
--- /dev/null	Thu Apr 30 20:52:30 2015
+++ new/usr/src/common/crypto/modes/amd64/gcm_intel_cryptogams.s	Thu Apr 30 20:52:30 2015
@@ -0,0 +1,512 @@
+/*
+ * Copyright (c) 2013, CRYPTOGAMS by <appro@openssl.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * *	Redistributions of source code must retain copyright notices,
+ *	this list of conditions and the following disclaimer.
+ *
+ * *	Redistributions in binary form must reproduce the above
+ *	copyright notice, this list of conditions and the following
+ *	disclaimer in the documentation and/or other materials
+ *	provided with the distribution.
+ *
+ * *	Neither the name of the CRYPTOGAMS nor the names of its
+ *	copyright holder and contributors may be used to endorse or
+ *	promote products derived from this software without specific
+ *	prior written permission.
+ *
+ * ALTERNATIVELY, provided that this notice is retained in full, this
+ * product may be distributed under the terms of the GNU General Public
+ * License (GPL), in which case the provisions of the GPL apply INSTEAD OF
+ * those given above.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/*
+ * Copyright 2015 by Saso Kiselkov on Illumos port sections.
+ */
+
+#if defined(lint) || defined(__lint)
+
+#include <sys/types.h>
+
+/*ARGSUSED*/
+void
+gcm_ghash_clmul(uint64_t ghash[2], const uint8_t Htable[256],
+    const uint8_t *inp, size_t len)
+{
+}
+
+/*ARGSUSED*/
+void
+gcm_init_clmul(const uint64_t hash_init[2], uint8_t Htable[256])
+{
+}
+
+#else	/* lint */
+
+#include <sys/asm_linkage.h>
+#include <sys/controlregs.h>
+#ifdef _KERNEL
+#include <sys/machprivregs.h>
+#endif
+
+.text
+.align XMM_ALIGN
+.Lbyte_swap16_mask:
+	.byte	15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0
+.L0x1c2_polynomial:
+	.byte	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xc2
+.L7_mask:
+	.long	7, 0, 7, 0
+
+#define	Xi	xmm0	/* hash value */
+#define	Xhi	xmm1	/* hash value high order 64 bits */
+#define	Hkey	xmm2	/* hash key */
+#define	T1	xmm3	/* temp1 */
+#define	T2	xmm4	/* temp2 */
+#define	T3	xmm5	/* temp3 */
+#define	Xb0	xmm6	/* cipher block #0 */
+#define	Xb1	xmm7	/* cipher block #1 */
+#define	Xb2	xmm8	/* cipher block #2 */
+#define	Xb3	xmm9	/* cipher block #3 */
+#define	Xb4	xmm10	/* cipher block #4 */
+#define	Xb5	xmm11	/* cipher block #5 */
+#define	Xb6	xmm12	/* cipher block #6 */
+#define	Xb7	xmm13	/* cipher block #7 */
+
+#define	clmul64x64_T2(tmpreg)				\
+	movdqa		%Xi, %Xhi;			\
+	pshufd		$0b01001110, %Xi, %T1;		\
+	pxor		%Xi, %T1;			\
+							\
+	pclmulqdq	$0x00, %Hkey, %Xi;		\
+	pclmulqdq	$0x11, %Hkey, %Xhi;		\
+	pclmulqdq	$0x00, %tmpreg, %T1;		\
+	pxor		%Xi, %T1;			\
+	pxor		%Xhi, %T1;			\
+							\
+	movdqa		%T1, %T2;			\
+	psrldq		$8, %T1;			\
+	pslldq		$8, %T2;			\
+	pxor		%T1, %Xhi;			\
+	pxor		%T2, %Xi
+
+#define	reduction_alg9					\
+	/* 1st phase */					\
+	movdqa		%Xi, %T2;			\
+	movdqa		%Xi, %T1;			\
+	psllq		$5, %Xi;			\
+	pxor		%Xi, %T1;			\
+	psllq		$1, %Xi;			\
+	pxor		%T1, %Xi;			\
+	psllq		$57, %Xi;			\
+	movdqa		%Xi, %T1;			\
+	pslldq		$8, %Xi;			\
+	psrldq		$8, %T1;			\
+	pxor		%T2, %Xi;			\
+	pxor		%T1, %Xhi;			\
+	/* 2nd phase */					\
+	movdqa		%Xi, %T2;			\
+	psrlq		$1, %Xi;			\
+	pxor		%T2, %Xhi;			\
+	pxor		%Xi, %T2;			\
+	psrlq		$5, %Xi;			\
+	pxor		%T2, %Xi;			\
+	psrlq		$1, %Xi;			\
+	pxor		%Xhi, %Xi
+
+#define	Xip	rdi
+#define	Htbl	rsi
+#define	inp	rdx
+#define	len	rcx
+
+#define	Xln	xmm6
+#define	Xmn	xmm7
+#define	Xhn	xmm8
+#define	Hkey2	xmm9
+#define	HK	xmm10
+#define	Xl	xmm11
+#define	Xm	xmm12
+#define	Xh	xmm13
+#define	Hkey3	xmm14
+#define	Hkey4	xmm15
+
+/*
+ * void gcm_ghash_clmul(uint64_t Xi[2], const uint64_t Htable[32],
+ *	const uint8_t *inp, size_t len)
+ */
+ENTRY_NP(gcm_ghash_clmul)
+	movdqa		.Lbyte_swap16_mask(%rip), %T3
+	mov		$0xA040608020C0E000, %rax	/ ((7..0) ? 0xE0) & 0xff
+
+	movdqu		(%Xip), %Xi
+	movdqu		(%Htbl), %Hkey
+	movdqu		0x20(%Htbl), %HK
+	pshufb		%T3, %Xi
+
+	sub		$0x10, %len
+	jz		.Lodd_tail
+
+	movdqu		0x10(%Htbl), %Hkey2
+
+	cmp		$0x30, %len
+	jb		.Lskip4x
+
+	sub		$0x30, %len
+	movdqu		0x30(%Htbl),%Hkey3
+	movdqu		0x40(%Htbl),%Hkey4
+
+	/* Xi+4 =[(H*Ii+3) + (H^2*Ii+2) + (H^3*Ii+1) + H^4*(Ii+Xi)] mod P */
+	movdqu		0x30(%inp), %Xln
+	movdqu		0x20(%inp), %Xl
+	pshufb		%T3, %Xln
+	pshufb		%T3, %Xl
+	movdqa		%Xln, %Xhn
+	pshufd		$0b01001110, %Xln, %Xmn
+	pxor		%Xln, %Xmn
+	pclmulqdq	$0x00, %Hkey, %Xln
+	pclmulqdq	$0x11, %Hkey, %Xhn
+	pclmulqdq	$0x00, %HK, %Xmn
+
+	movdqa		%Xl, %Xh
+	pshufd		$0b01001110, %Xl, %Xm
+	pxor		%Xl, %Xm
+	pclmulqdq	$0x00, %Hkey2, %Xl
+	pclmulqdq	$0x11, %Hkey2, %Xh
+	xorps		%Xl, %Xln
+	pclmulqdq	$0x10, %HK, %Xm
+	xorps		%Xh, %Xhn
+	movups		0x50(%Htbl), %HK
+	xorps		%Xm, %Xmn
+
+	movdqu		0x10(%inp), %Xl
+	movdqu		0x00(%inp), %T1
+	pshufb		%T3, %Xl
+	pshufb		%T3, %T1
+	movdqa		%Xl, %Xh
+	pshufd		$0b01001110, %Xl, %Xm
+	pxor		%T1, %Xi
+	pxor		%Xl, %Xm
+	pclmulqdq	$0x00, %Hkey3, %Xl
+	movdqa		%Xi, %Xhi
+	pshufd		$0b01001110, %Xi, %T1
+	pxor		%Xi, %T1
+	pclmulqdq	$0x11, %Hkey3, %Xh
+	xorps		%Xl, %Xln
+	pclmulqdq	$0x00, %HK, %Xm
+	xorps		%Xh, %Xhn
+
+	lea		0x40(%inp), %inp
+	sub		$0x40, %len
+	jc		.Ltail4x
+
+	jmp		.Lmod4_loop
+
+.align	32
+.Lmod4_loop:
+	pclmulqdq	$0x00, %Hkey4, %Xi
+	xorps		%Xm, %Xmn
+	movdqu		0x30(%inp), %Xl
+	pshufb		%T3, %Xl
+	pclmulqdq	$0x11, %Hkey4, %Xhi
+	xorps		%Xln, %Xi
+	movdqu		0x20(%inp), %Xln
+	movdqa		%Xl, %Xh
+	pshufd		$0b01001110, %Xl, %Xm
+	pclmulqdq	$0x10, %HK, %T1
+	xorps		%Xhn, %Xhi
+	pxor		%Xl, %Xm
+	pshufb		%T3, %Xln
+	movups		0x20(%Htbl), %HK
+	pclmulqdq	$0x00, %Hkey, %Xl
+	xorps		%Xmn, %T1
+	movdqa		%Xln, %Xhn
+	pshufd		$0b01001110, %Xln, %Xmn
+
+	pxor		%Xi, %T1	/ aggregated Karatsuba post-processing
+	pxor		%Xln, %Xmn
+	pxor		%Xhi, %T1
+	movdqa		%T1, %T2
+	pslldq		$8, %T1
+	pclmulqdq	$0x11, %Hkey, %Xh
+	psrldq		$8, %T2
+	pxor		%T1, %Xi
+	movdqa		.L7_mask(%rip), %T1
+	pxor		%T2, %Xhi
+	movq		%rax, %T2
+
+	pand		%Xi, %T1	/ 1st phase
+	pshufb		%T1, %T2
+	pclmulqdq	$0x00, %HK, %Xm
+	pxor		%Xi, %T2
+	psllq		$57, %T2
+	movdqa		%T2, %T1
+	pslldq		$8, %T2
+	pclmulqdq	$0x00, %Hkey2, %Xln
+	psrldq		$8, %T1
+	pxor		%T2, %Xi
+	pxor		%T1, %Xhi
+	movdqu		0(%inp), %T1
+
+	movdqa		%Xi, %T2	/ 2nd phase
+	psrlq		$1, %Xi
+	pclmulqdq	$0x11, %Hkey2, %Xhn
+	xorps		%Xl, %Xln
+	movdqu		0x10(%inp), %Xl
+	pshufb		%T3, %Xl
+	pclmulqdq	$0x10, %HK, %Xmn
+	xorps		%Xh, %Xhn
+	movups		0x50(%Htbl), %HK
+	pshufb		%T3, %T1
+	pxor		%T2, %Xhi
+	pxor		%Xi, %T2
+	psrlq		$5, %Xi
+
+	movdqa		%Xl, %Xh
+	pxor		%Xm, %Xmn
+	pshufd		$0b01001110, %Xl, %Xm
+	pxor		%Xl, %Xm
+	pclmulqdq	$0x00, %Hkey3, %Xl
+	pxor		%T2, %Xi
+	pxor		%T1, %Xhi
+	psrlq		$1, %Xi
+	pclmulqdq	$0x11, %Hkey3, %Xh
+	xorps		%Xl, %Xln
+	pxor		%Xhi, %Xi
+
+	pclmulqdq	$0x00, %HK, %Xm
+	xorps		%Xh, %Xhn
+
+	movdqa		%Xi, %Xhi
+	pshufd		$0b01001110, %Xi, %T1
+	pxor		%Xi, %T1
+
+	lea		0x40(%inp), %inp
+	sub		$0x40, %len
+	jnc		.Lmod4_loop
+
+.Ltail4x:
+	pclmulqdq	$0x00, %Hkey4, %Xi
+	xorps		%Xm, %Xmn
+	pclmulqdq	$0x11, %Hkey4, %Xhi
+	xorps		%Xln, %Xi
+	pclmulqdq	$0x10, %HK, %T1
+	xorps		%Xhn, %Xhi
+	pxor		%Xi, %Xhi	/ aggregated Karatsuba post-processing
+	pxor		%Xmn, %T1
+
+	pxor		%Xhi, %T1
+	pxor		%Xi, %Xhi
+
+	movdqa		%T1, %T2
+	psrldq		$8, %T1
+	pslldq		$8, %T2
+	pxor		%T1, %Xhi
+	pxor		%T2, %Xi
+
+	reduction_alg9
+
+	add	$0x40, %len
+	jz	.Ldone
+	movdqu	0x20(%Htbl), %HK
+	sub	$0x10, %len
+	jz	.Lodd_tail
+.Lskip4x:
+
+	/*
+	 * Xi+2 =[H*(Ii+1 + Xi+1)] mod P =
+	 *	[(H*Ii+1) + (H*Xi+1)] mod P =
+	 *	[(H*Ii+1) + H^2*(Ii+Xi)] mod P
+	 */
+	movdqu		(%inp), %T1		/ Ii
+	movdqu		16(%inp), %Xln		/ Ii+1
+	pshufb		%T3, %T1
+	pshufb		%T3, %Xln
+	pxor		%T1, %Xi		/ Ii+Xi
+
+	movdqa		%Xln, %Xhn
+	pshufd		$0b01001110, %Xln, %T1
+	pxor		%Xln, %T1
+	pclmulqdq	$0x00, %Hkey, %Xln
+	pclmulqdq	$0x11, %Hkey, %Xhn
+	pclmulqdq	$0x00, %HK, %T1
+
+	lea		32(%inp), %inp		/ i+=2
+	sub		$0x20, %len
+	jbe		.Leven_tail
+	jmp		.Lmod_loop
+
+.align	32
+.Lmod_loop:
+	movdqa		%Xi, %Xhi
+	pshufd		$0b01001110, %Xi, %T2
+	pxor		%Xi, %T2
+
+	pclmulqdq	$0x00, %Hkey2, %Xi
+	pclmulqdq	$0x11, %Hkey2, %Xhi
+	pclmulqdq	$0x10, %HK, %T2
+
+	pxor		%Xln, %Xi		/ (H*Ii+1) + H^2*(Ii+Xi)
+	pxor		%Xhn, %Xhi
+	movdqu		(%inp), %Xhn		/ Ii
+	pshufb		%T3, %Xhn
+	movdqu		16(%inp), %Xln		/ Ii+1
+
+	pxor		%Xi, %T1		/ aggregated Karatsuba post-proc
+	pxor		%Xhi, %T1
+	pxor		%Xhn, %Xhi		/ "Ii+Xi",  consume early
+	pxor		%T1, %T2
+	pshufb		%T3, %Xln
+	movdqa		%T2, %T1
+	psrldq		$8, %T1
+	pslldq		$8, %T2
+	pxor		%T1, %Xhi
+	pxor		%T2, %Xi
+
+	movdqa		%Xln, %Xhn
+
+	movdqa		%Xi, %T2		/ 1st phase
+	movdqa		%Xi, %T1
+	psllq		$5, %Xi
+	pclmulqdq	$0x00, %Hkey, %Xln
+	pxor		%Xi, %T1
+	psllq		$1, %Xi
+	pxor		%T1, %Xi
+	psllq		$57, %Xi
+	movdqa		%Xi, %T1
+	pslldq		$8, %Xi
+	psrldq		$8, %T1
+	pxor		%T2, %Xi
+	pxor		%T1, %Xhi
+	pshufd		$0b01001110, %Xhn, %T1
+	pxor		%Xhn, %T1
+
+	pclmulqdq	$0x11, %Hkey, %Xhn
+	movdqa		%Xi, %T2		/ 2nd phase
+	psrlq		$1, %Xi
+	pxor		%T2, %Xhi
+	pxor		%Xi, %T2
+	psrlq		$5, %Xi
+	pxor		%T2, %Xi
+	psrlq		$1, %Xi
+	pclmulqdq	$0x00, %HK, %T1
+	pxor		%Xhi, %Xi
+
+	lea		32(%inp), %inp
+	sub		$0x20, %len
+	ja		.Lmod_loop
+
+.Leven_tail:
+	movdqa		%Xi, %Xhi
+	pshufd		$0b01001110, %Xi, %T2
+	pxor		%Xi, %T2
+
+	pclmulqdq	$0x00, %Hkey2, %Xi
+	pclmulqdq	$0x11, %Hkey2, %Xhi
+	pclmulqdq	$0x10, %HK, %T2
+
+	pxor		%Xln, %Xi		/* (H*Ii+1) + H^2*(Ii+Xi) */
+	pxor		%Xhn, %Xhi
+	pxor		%Xi, %T1
+	pxor		%Xhi, %T1
+	pxor		%T1, %T2
+	movdqa		%T2, %T1
+	psrldq		$8, %T1
+	pslldq		$8, %T2
+	pxor		%T1, %Xhi
+	pxor		%T2, %Xi
+
+	reduction_alg9
+
+	test		%len, %len
+	jnz		.Ldone
+
+.Lodd_tail:
+	movdqu		(%inp), %T1			/ Ii
+	pshufb		%T3, %T1
+	pxor		%T1, %Xi			/ Ii+Xi
+
+	clmul64x64_T2(HK)				/ H*(Ii+Xi)
+	reduction_alg9
+
+.Ldone:
+	pshufb		%T3, %Xi
+	movdqu		%Xi, (%Xip)
+
+	ret
+	SET_SIZE(gcm_ghash_clmul)
+
+/*
+ * void gcm_init_clmul(const void *Xi, void *Htable)
+ */
+ENTRY_NP(gcm_init_clmul)
+	movdqu		(%Xip), %Hkey
+	pshufd		$0b01001110, %Hkey, %Hkey	/ dword swap
+
+	/ <<1 twist
+	pshufd		$0b11111111, %Hkey, %T2	/ broadcast uppermost dword
+	movdqa		%Hkey, %T1
+	psllq		$1, %Hkey
+	pxor		%T3, %T3
+	psrlq		$63, %T1
+	pcmpgtd		%T2, %T3		/ broadcast carry bit
+	pslldq		$8, %T1
+	por		%T1, %Hkey		/ H<<=1
+
+	/ magic reduction
+	pand		.L0x1c2_polynomial(%rip), %T3
+	pxor		%T3, %Hkey		/ if(carry) H^=0x1c2_polynomial
+
+	/ calculate H^2
+	pshufd		$0b01001110, %Hkey, %HK
+	movdqa		%Hkey, %Xi
+	pxor		%Hkey, %HK
+
+	clmul64x64_T2(HK)
+	reduction_alg9
+
+	pshufd		$0b01001110, %Hkey, %T1
+	pshufd		$0b01001110, %Xi, %T2
+	pxor		%Hkey, %T1		/ Karatsuba pre-processing
+	movdqu		%Hkey, 0x00(%Htbl)	/ save H
+	pxor		%Xi, %T2		/ Karatsuba pre-processing
+	movdqu		%Xi, 0x10(%Htbl)	/ save H^2
+	palignr		$8, %T1, %T2		/ low part is H.lo^H.hi...
+	movdqu		%T2, 0x20(%Htbl)	/ save Karatsuba "salt"
+
+	clmul64x64_T2(HK)			/ H^3
+	reduction_alg9
+
+	movdqa		%Xi, %T3
+
+	clmul64x64_T2(HK)			/ H^4
+	reduction_alg9
+
+	pshufd		$0b01001110, %T3, %T1
+	pshufd		$0b01001110, %Xi, %T2
+	pxor		%T3, %T1		/ Karatsuba pre-processing
+	movdqu		%T3, 0x30(%Htbl)	/ save H^3
+	pxor		%Xi, %T2		/ Karatsuba pre-processing
+	movdqu		%Xi, 0x40(%Htbl)	/ save H^4
+	palignr		$8, %T1, %T2		/ low part is H^3.lo^H^3.hi...
+	movdqu		%T2, 0x50(%Htbl)	/ save Karatsuba "salt"
+
+	ret
+	SET_SIZE(gcm_init_clmul)
+
+#endif	/* lint || __lint */
--- old/usr/src/common/crypto/modes/cbc.c	Thu Apr 30 20:52:30 2015
+++ new/usr/src/common/crypto/modes/cbc.c	Thu Apr 30 20:52:30 2015
@@ -22,6 +22,9 @@
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #ifndef _KERNEL
 #include <strings.h>
@@ -31,10 +34,43 @@
 #endif
 
 #include <sys/types.h>
+#define	INLINE_CRYPTO_GET_PTRS
 #include <modes/modes.h>
 #include <sys/crypto/common.h>
 #include <sys/crypto/impl.h>
 
+boolean_t cbc_fastpath_enabled = B_TRUE;
+
+static void
+cbc_decrypt_fastpath(cbc_ctx_t *ctx, const uint8_t *data, size_t length,
+    uint8_t *out, size_t block_size,
+    int (*decrypt)(const void *, const uint8_t *, uint8_t *),
+    int (*decrypt_ecb)(const void *, const uint8_t *, uint8_t *, uint64_t),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    void (*xor_block_range)(const uint8_t *, uint8_t *, uint64_t))
+{
+	const uint8_t *iv = (uint8_t *)ctx->cbc_iv;
+
+	/* Use bulk decryption when available. */
+	if (decrypt_ecb != NULL) {
+		decrypt_ecb(ctx->cbc_keysched, data, out, length);
+	} else {
+		for (size_t i = 0; i < length; i += block_size)
+			decrypt(ctx->cbc_keysched, &data[i], &out[i]);
+	}
+
+	/* Use bulk XOR when available. */
+	if (xor_block_range != NULL && length >= 2 * block_size) {
+		xor_block(iv, out);
+		xor_block_range(data, &out[block_size], length - block_size);
+	} else {
+		for (size_t i = 0; i < length; i += block_size) {
+			xor_block(iv, &out[i]);
+			iv = &data[i];
+		}
+	}
+}
+
 /*
  * Algorithm independent CBC functions.
  */
@@ -42,8 +78,10 @@
 cbc_encrypt_contiguous_blocks(cbc_ctx_t *ctx, char *data, size_t length,
     crypto_data_t *out, size_t block_size,
     int (*encrypt)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*encrypt_cbc)(const void *, const uint8_t *, uint8_t *,
+    const uint8_t *, uint64_t))
 {
 	size_t remainder = length;
 	size_t need;
@@ -56,6 +94,31 @@
 	uint8_t *out_data_2;
 	size_t out_data_1_len;
 
+	/*
+	 * CBC encryption fastpath requirements:
+	 * - fastpath is enabled
+	 * - algorithm-specific acceleration function is available
+	 * - input is block-aligned
+	 * - output is a single contiguous region or the user requested that
+	 *   we overwrite their input buffer (input/output aliasing allowed)
+	 */
+	if (cbc_fastpath_enabled && encrypt_cbc != NULL && length != 0 &&
+	    ctx->cbc_remainder_len == 0 && (length & (block_size - 1)) == 0 &&
+	    (out == NULL || CRYPTO_DATA_IS_SINGLE_BLOCK(out))) {
+		if (out == NULL) {
+			encrypt_cbc(ctx->cbc_keysched, (uint8_t *)data,
+			    (uint8_t *)data, (uint8_t *)ctx->cbc_iv, length);
+			ctx->cbc_lastp = (uint8_t *)&data[length - block_size];
+		} else {
+			uint8_t *outp = CRYPTO_DATA_FIRST_BLOCK(out);
+			encrypt_cbc(ctx->cbc_keysched, (uint8_t *)data, outp,
+			    (uint8_t *)ctx->cbc_iv, length);
+			out->cd_offset += length;
+			ctx->cbc_lastp = &outp[length - block_size];
+		}
+		goto out;
+	}
+
 	if (length + ctx->cbc_remainder_len < block_size) {
 		/* accumulate bytes here and return */
 		bcopy(datap,
@@ -169,8 +232,10 @@
 cbc_decrypt_contiguous_blocks(cbc_ctx_t *ctx, char *data, size_t length,
     crypto_data_t *out, size_t block_size,
     int (*decrypt)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*decrypt_ecb)(const void *, const uint8_t *, uint8_t *, uint64_t),
+    void (*xor_block_range)(const uint8_t *, uint8_t *, uint64_t))
 {
 	size_t remainder = length;
 	size_t need;
@@ -183,6 +248,26 @@
 	uint8_t *out_data_2;
 	size_t out_data_1_len;
 
+	/*
+	 * CBC decryption fastpath requirements:
+	 * - fastpath is enabled
+	 * - input is block-aligned
+	 * - output is a single contiguous region and doesn't alias input
+	 */
+	if (cbc_fastpath_enabled && ctx->cbc_remainder_len == 0 &&
+	    length != 0 && (length & (block_size - 1)) == 0 &&
+	    CRYPTO_DATA_IS_SINGLE_BLOCK(out)) {
+		uint8_t *outp = CRYPTO_DATA_FIRST_BLOCK(out);
+
+		cbc_decrypt_fastpath(ctx, (uint8_t *)data, length, outp,
+		    block_size, decrypt, decrypt_ecb, xor_block,
+		    xor_block_range);
+		out->cd_offset += length;
+		bcopy(&data[length - block_size], ctx->cbc_iv, block_size);
+		ctx->cbc_lastp = (uint8_t *)ctx->cbc_iv;
+		return (CRYPTO_SUCCESS);
+	}
+
 	if (length + ctx->cbc_remainder_len < block_size) {
 		/* accumulate bytes here and return */
 		bcopy(datap,
@@ -280,7 +365,7 @@
 
 int
 cbc_init_ctx(cbc_ctx_t *cbc_ctx, char *param, size_t param_len,
-    size_t block_size, void (*copy_block)(uint8_t *, uint64_t *))
+    size_t block_size, void (*copy_block)(const uint8_t *, uint64_t *))
 {
 	/*
 	 * Copy IV into context.
--- old/usr/src/common/crypto/modes/ccm.c	Thu Apr 30 20:52:31 2015
+++ new/usr/src/common/crypto/modes/ccm.c	Thu Apr 30 20:52:31 2015
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
  */
 
 #ifndef _KERNEL
@@ -31,6 +32,7 @@
 
 #include <sys/types.h>
 #include <sys/kmem.h>
+#define	INLINE_CRYPTO_GET_PTRS
 #include <modes/modes.h>
 #include <sys/crypto/common.h>
 #include <sys/crypto/impl.h>
@@ -48,8 +50,8 @@
 ccm_mode_encrypt_contiguous_blocks(ccm_ctx_t *ctx, char *data, size_t length,
     crypto_data_t *out, size_t block_size,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *))
 {
 	size_t remainder = length;
 	size_t need;
@@ -206,7 +208,7 @@
 int
 ccm_encrypt_final(ccm_ctx_t *ctx, crypto_data_t *out, size_t block_size,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*xor_block)(const uint8_t *, uint8_t *))
 {
 	uint8_t *lastp, *mac_buf, *ccm_mac_p, *macp;
 	void *iov_or_mp;
@@ -359,8 +361,8 @@
 ccm_mode_decrypt_contiguous_blocks(ccm_ctx_t *ctx, char *data, size_t length,
     crypto_data_t *out, size_t block_size,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *))
 {
 	size_t remainder = length;
 	size_t need;
@@ -526,8 +528,8 @@
 int
 ccm_decrypt_final(ccm_ctx_t *ctx, crypto_data_t *out, size_t block_size,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *))
 {
 	size_t mac_remain, pt_len;
 	uint8_t *pt, *mac_buf, *macp, *ccm_mac_p;
@@ -770,7 +772,7 @@
 ccm_init(ccm_ctx_t *ctx, unsigned char *nonce, size_t nonce_len,
     unsigned char *auth_data, size_t auth_data_len, size_t block_size,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*xor_block)(const uint8_t *, uint8_t *))
 {
 	uint8_t *mac_buf, *datap, *ivp, *authp;
 	size_t remainder, processed;
@@ -854,7 +856,7 @@
 ccm_init_ctx(ccm_ctx_t *ccm_ctx, char *param, int kmflag,
     boolean_t is_encrypt_init, size_t block_size,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*xor_block)(const uint8_t *, uint8_t *))
 {
 	int rv;
 	CK_AES_CCM_PARAMS *ccm_param;
--- old/usr/src/common/crypto/modes/ctr.c	Thu Apr 30 20:52:31 2015
+++ new/usr/src/common/crypto/modes/ctr.c	Thu Apr 30 20:52:31 2015
@@ -22,6 +22,9 @@
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #ifndef _KERNEL
 #include <strings.h>
@@ -31,11 +34,15 @@
 #endif
 
 #include <sys/types.h>
+#define	INLINE_CRYPTO_GET_PTRS
 #include <modes/modes.h>
 #include <sys/crypto/common.h>
 #include <sys/crypto/impl.h>
 #include <sys/byteorder.h>
+#include <sys/cmn_err.h>
 
+boolean_t ctr_fastpath_enabled = B_TRUE;
+
 /*
  * Encrypt and decrypt multiple blocks of data in counter mode.
  */
@@ -43,7 +50,9 @@
 ctr_mode_contiguous_blocks(ctr_ctx_t *ctx, char *data, size_t length,
     crypto_data_t *out, size_t block_size,
     int (*cipher)(const void *ks, const uint8_t *pt, uint8_t *ct),
-    void (*xor_block)(uint8_t *, uint8_t *))
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*cipher_ctr)(const void *ks, const uint8_t *pt, uint8_t *ct,
+    uint64_t len, uint64_t counter[2]))
 {
 	size_t remainder = length;
 	size_t need;
@@ -57,6 +66,24 @@
 	size_t out_data_1_len;
 	uint64_t lower_counter, upper_counter;
 
+	/*
+	 * CTR encryption/decryption fastpath requirements:
+	 * - fastpath is enabled
+	 * - algorithm-specific acceleration function is available
+	 * - input is block-aligned
+	 * - the counter value won't overflow the lower counter mask
+	 * - output is a single contiguous region and doesn't alias input
+	 */
+	if (ctr_fastpath_enabled && cipher_ctr != NULL &&
+	    ctx->ctr_remainder_len == 0 && (length & (block_size - 1)) == 0 &&
+	    ntohll(ctx->ctr_cb[1]) <= ctx->ctr_lower_mask -
+	    length / block_size && CRYPTO_DATA_IS_SINGLE_BLOCK(out)) {
+		cipher_ctr(ctx->ctr_keysched, (uint8_t *)data,
+		    CRYPTO_DATA_FIRST_BLOCK(out), length, ctx->ctr_cb);
+		out->cd_offset += length;
+		return (CRYPTO_SUCCESS);
+	}
+
 	if (length + ctx->ctr_remainder_len < block_size) {
 		/* accumulate bytes here and return */
 		bcopy(datap,
@@ -205,7 +232,7 @@
 
 int
 ctr_init_ctx(ctr_ctx_t *ctr_ctx, ulong_t count, uint8_t *cb,
-void (*copy_block)(uint8_t *, uint8_t *))
+    void (*copy_block)(const uint8_t *, uint8_t *))
 {
 	uint64_t upper_mask = 0;
 	uint64_t lower_mask = 0;
